<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="A punctuated sequence of syntax tree nodes separated by punctuation."><meta name="keywords" content="rust, rustlang, rust-lang, punctuated"><title>syn::punctuated - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module punctuated</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../syn/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">syn</a>::<wbr><a class="mod" href="#">punctuated</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/syn/punctuated.rs.html#1-1068">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>A punctuated sequence of syntax tree nodes separated by punctuation.</p>
<p>Lots of things in Rust are punctuated sequences.</p>
<ul>
<li>The fields of a struct are <code>Punctuated&lt;Field, Token![,]&gt;</code>.</li>
<li>The segments of a path are <code>Punctuated&lt;PathSegment, Token![::]&gt;</code>.</li>
<li>The bounds on a generic parameter are <code>Punctuated&lt;TypeParamBound, Token![+]&gt;</code>.</li>
<li>The arguments to a function call are <code>Punctuated&lt;Expr, Token![,]&gt;</code>.</li>
</ul>
<p>This module provides a common representation for these punctuated sequences
in the form of the <a href="struct.Punctuated.html"><code>Punctuated&lt;T, P&gt;</code></a> type. We store a vector of pairs of
syntax tree node + punctuation, where every node in the sequence is followed
by punctuation except for possibly the final one.</p>
<div class="example-wrap"><pre class="language-text"><code>a_function_call(arg1, arg2, arg3);
                ~~~~^ ~~~~^ ~~~~</code></pre></div></div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.IntoIter.html" title="syn::punctuated::IntoIter struct">IntoIter</a></div><div class="item-right docblock-short"><p>An iterator over owned values of type <code>T</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.IntoPairs.html" title="syn::punctuated::IntoPairs struct">IntoPairs</a></div><div class="item-right docblock-short"><p>An iterator over owned pairs of type <code>Pair&lt;T, P&gt;</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Iter.html" title="syn::punctuated::Iter struct">Iter</a></div><div class="item-right docblock-short"><p>An iterator over borrowed values of type <code>&amp;T</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.IterMut.html" title="syn::punctuated::IterMut struct">IterMut</a></div><div class="item-right docblock-short"><p>An iterator over mutably borrowed values of type <code>&amp;mut T</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Pairs.html" title="syn::punctuated::Pairs struct">Pairs</a></div><div class="item-right docblock-short"><p>An iterator over borrowed pairs of type <code>Pair&lt;&amp;T, &amp;P&gt;</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.PairsMut.html" title="syn::punctuated::PairsMut struct">PairsMut</a></div><div class="item-right docblock-short"><p>An iterator over mutably borrowed pairs of type <code>Pair&lt;&amp;mut T, &amp;mut P&gt;</code>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Punctuated.html" title="syn::punctuated::Punctuated struct">Punctuated</a></div><div class="item-right docblock-short"><p>A punctuated sequence of syntax tree nodes of type <code>T</code> separated by
punctuation of type <code>P</code>.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Pair.html" title="syn::punctuated::Pair enum">Pair</a></div><div class="item-right docblock-short"><p>A single syntax tree node of type <code>T</code> followed by its trailing punctuation
of type <code>P</code> if any.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>